/*
 * abasic
 * Copyright (C) 2007 m_inaba
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "./abasic.h"

static char buff[16];
static char buff2[256];

int main(int argc, char* argv[]){
	if(argc>1){
		if(!basic_init(argv[1])){
			//R}hCC^v^̕ϐɊi[
			int i;
			for(i=0;i<argc;i++){
				sprintf(buff,"args[\"%d\"]",i+1);
				sprintf(buff2,"\"%s",argv[i]);
				setVariable(buff,buff2);
			}
			sprintf(buff,"args[\"%d\"]",i+1);
			setVariable(buff,"\",");
			basic_setup();
			basic_start(1);//basicC^v^̊Jn
			basic_end();
		}else{
			printf("%s\n","error");
		}
	}else{
		source_init();
		int i=0;
		//-------------------------------------------
		//R\[d̃R[h[h
		//-------------------------------------------
		source_add("system.err.output=2"						,i++);
		source_add("system.err.exit=0"						,i++);
		source_add("print \"v\" + system.version + \" (\" + system.build + \"bit build)\"",i++);
		source_add("while 1"								,i++);
		source_add(	"output \">\""							,i++);
		source_add(	"input str1234"							,i++);
		source_add(	"trim str1234"							,i++);
		source_add(	"if str1234<>\"\" then"						,i++);
		source_add(		"left str1234,1"					,i++);
		source_add(		"match \"[-+(0-9]\",left"				,i++);
		source_add(		"if match==\"\" then"					,i++);
		source_add(			"if left==\"=\" then"				,i++);
		source_add(				"eval \"ans1234\"+str1234"		,i++);
		source_add(				"print ans1234"				,i++);
		source_add(			"else"						,i++);
		source_add(				"eval str1234"				,i++);
		source_add(			"endif"						,i++);
		source_add(		"else"							,i++);
		source_add(			"eval \"ans1234=\"+str1234"			,i++);
		source_add(			"print ans1234"					,i++);
		source_add(		"endif"							,i++);
		source_add(	"endif"								,i++);
		source_add("wend"								,i++);
		//-------------------------------------------
		source_end();
		basic_setup();
		basic_start(1);//C^v^̊Jn
		basic_end();
	}
	return 0;
}

//-------------------------------------------------------------------------------
